/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.iotdb.db.schemaengine.table;

import org.apache.iotdb.commons.schema.table.TsTable;

public interface ITableCache {

  void init(final byte[] tableInitializationBytes);

  void preUpdateTable(final String database, final TsTable table);

  void rollbackUpdateTable(final String database, final String tableName);

  void commitUpdateTable(final String database, final String tableName);

  /**
   * @param database shouldn't start with `root.`
   */
  void invalid(final String database);

  void invalid(final String database, final String tableName);

  void invalid(final String database, final String tableName, final String columnName);
}
